package com.zcloud.controller.majordangersource;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.service.majordangersource.MajorDangerSourceLogService;
import com.zcloud.service.majordangersource.MajorDangerSourceService;
import com.zcloud.service.majordangersource.MonitoringDeviceDisableService;
import com.zcloud.service.majordangersource.MonitoringDeviceService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：监测设备停用记录
 * 作者：luoxiaobao
 * 时间：2022-04-01
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/monitoringdevicedisable")
public class MonitoringDeviceDisableController extends BaseController {

	@Autowired
	private MonitoringDeviceDisableService monitoringdevicedisableService;

	@Autowired
	private MajorDangerSourceService majordangersourceService;
	@Autowired
	private MajorDangerSourceLogService majordangersourcelogService;
	@Autowired
	private MonitoringDeviceService monitoringDeviceService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("monitoringdevice:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("MONITORINGDEVICEDISABLE_ID", this.get32UUID());	//主键
//		pd.put("DISABLE_TIME_START", pd.getString("DISABLE_TIME_START")+":00");
//		pd.put("DISABLE_TIME_END", pd.getString("DISABLE_TIME_END").endsWith(":00")? pd.getString("DISABLE_TIME_END")+":59:59" : pd.getString("DISABLE_TIME_END")+":59");
		pd.put("ISDELETE", "0");	//是否删除(0:有效 1：删除 2：无效记录)
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		monitoringdevicedisableService.save(pd);

		//设备信息改为重大危险源
//		PageData device = monitoringDeviceService.findById(pd);
//		device.put("MONITORINGDEVICE_STATUS",pd.getString("DISABLE_STATUS"));
//		device.put("OPERATOR", pd.getString("OPERATOR"));	//修改人
//		device.put("OPERATTIME", pd.getString("OPERATTIME"));	//修改时间
//		monitoringDeviceService.edit(device);
		PageData source = majordangersourceService.findById(pd);
		source.put("MAJORDANGERSOURCE_STATUS",pd.getString("DISABLE_STATUS"));
		source.put("OPERATOR", pd.getString("OPERATOR"));	//修改人
		source.put("OPERATTIME", pd.getString("OPERATTIME"));	//修改时间
		majordangersourceService.edit(source);
		source.put("CREATOR", pd.getString("CREATOR"));	//修改人
		source.put("CREATTIME", pd.getString("CREATTIME"));	//修改时间
		source.put("MAJORDANGERSOURCELOG_ID", this.get32UUID());	//主键
		majordangersourcelogService.save(source);

		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("monitoringdevice:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		monitoringdevicedisableService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("monitoringdevice:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		monitoringdevicedisableService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("monitoringdevice:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = monitoringdevicedisableService.list(page);	//列出MonitoringDeviceDisable列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("monitoringdevice:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = monitoringdevicedisableService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("monitoringdevice:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String[] ArrayDATA_IDS = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			monitoringdevicedisableService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("设备ID");	//1
		titles.add("停用状态（2.停用、3.检修）");	//2
		titles.add("停用开始时间");	//3
		titles.add("停用结束时间");	//4
		titles.add("停用原因");	//5
		titles.add("停用人");	//6
		titles.add("是否删除(0:有效 1：删除 2：无效记录)");	//7
		titles.add("添加人");	//8
		titles.add("添加时间");	//9
		titles.add("修改人");	//10
		titles.add("修改时间");	//11
		titles.add("企业ID");	//12
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = monitoringdevicedisableService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("MONITORINGDEVICE_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("DISABLE_STATUS"));	    //2
			vpd.put("var3", varOList.get(i).getString("DISABLE_TIME_START"));	    //3
			vpd.put("var4", varOList.get(i).getString("DISABLE_TIME_END"));	    //4
			vpd.put("var5", varOList.get(i).getString("DISABLE_REASON"));	    //5
			vpd.put("var6", varOList.get(i).getString("DISABLE_USER"));	    //6
			vpd.put("var7", varOList.get(i).getString("ISDELETE"));	    //7
			vpd.put("var8", varOList.get(i).getString("CREATOR"));	    //8
			vpd.put("var9", varOList.get(i).getString("CREATTIME"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATOR"));	    //10
			vpd.put("var11", varOList.get(i).getString("OPERATTIME"));	    //11
			vpd.put("var12", varOList.get(i).getString("CORPINFO_ID"));	    //12
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
